summaryrefslogtreecommitdiffstats
path: root/tests/ts/lsns
diff options
context:
space:
mode:
authorMasatake YAMATO2017-11-24 11:31:09 +0100
committerKarel Zak2017-11-27 15:54:57 +0100
commit94d4ccd7a2af5711be9d092e86a8efb19c0b4697 (patch)
treee15baf5735997137f6f68d51f536a467198eda0c /tests/ts/lsns
parentlsns: add --nowrap(-W) option (diff)
downloadkernel-qcow2-util-linux-94d4ccd7a2af5711be9d092e86a8efb19c0b4697.tar.gz
kernel-qcow2-util-linux-94d4ccd7a2af5711be9d092e86a8efb19c0b4697.tar.xz
kernel-qcow2-util-linux-94d4ccd7a2af5711be9d092e86a8efb19c0b4697.zip
lsns: add a case for testing nsfs column
Signed-off-by: Masatake YAMATO <yamato@redhat.com>
Diffstat (limited to 'tests/ts/lsns')
-rw-r--r--tests/ts/lsns/nsfs68
1 files changed, 68 insertions, 0 deletions
diff --git a/tests/ts/lsns/nsfs b/tests/ts/lsns/nsfs
new file mode 100644
index 000000000..7f2b46bbe
--- /dev/null
+++ b/tests/ts/lsns/nsfs
@@ -0,0 +1,68 @@
+#!/bin/bash
+#
+# Copyright (C) 2017 Masatake YAMATO <yamato@redhat.com>
+#
+# This file is part of util-linux.
+#
+# This file is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This file is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+
+TS_TOPDIR="${0%/*}/../.."
+TS_DESC="list NSFS for namespaces created by ip-netns-add"
+
+. $TS_TOPDIR/functions.sh
+ts_init "$*"
+
+ts_check_test_command "$TS_CMD_LSNS"
+
+ts_skip_nonroot
+
+ts_cd "$TS_OUTDIR"
+
+NAME1=ABC
+NAME2=XYZ
+PATH1=/run/netns/$NAME1
+PATH2=$TS_OUTDIR/$NAME2
+FIFO=$TS_OUTDIR/UTIL-LINUX-LSNS-TEST-FIFO
+NULL=/dev/null
+
+ip netns delete $NAME1 2> /dev/null || :
+umount $PATH2 2>/dev/null || :
+rm -f $PATH2
+
+rm -f $FIFO
+mkfifo $FIFO
+
+if ip netns add $NAME1 &&
+ touch ${PATH2} &&
+ mount -o bind ${PATH1} ${PATH2}; then
+ ip netns exec $NAME1 dd if=$FIFO bs=1 count=2 of=$NULL 2> $NULL &
+ PID=$!
+fi
+{
+ dd if=/dev/zero bs=1 count=1 2> $NULL
+ NSFS_NAMES_MLINES=$($TS_CMD_LSNS -n -o NSFS --type net --task $PID | { while read VAL; do echo $VAL; done; } )
+ NSFS_NAMES_1LINE=$($TS_CMD_LSNS -n -o NSFS --nowrap --type net --task $PID | { while read VAL; do echo $VAL; done; } )
+ dd if=/dev/zero bs=1 count=1 2> $NULL
+} > $FIFO
+
+rm $FIFO
+
+umount $PATH2
+rm -f $PATH2
+ip netns delete $NAME1
+
+test "$NSFS_NAMES_MLINES" = "$PATH1
+$PATH2" && test "$NSFS_NAMES_1LINE" = "$PATH1,$PATH2"
+
+echo $? >> $TS_OUTPUT
+
+ts_finalize